//  BMP
//  Copyright (C) 2005-2007 BMP development.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non GPL-compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_NETWORK_TYPES_HH
#define BMP_NETWORK_TYPES_HH

#include "minisoup.hh"
#include <boost/shared_ptr.hpp>
#include <glibmm/ustring.hh>
#include <map>

using namespace Glib;

namespace Bmp
{
    namespace Network
    {
        struct DownloadContextBase
        {
          Soup::RequestFileRefP FileRequest;
          ustring               Uri;
          ustring               LocalUri;
          double                DownloadProgress;
        };

        typedef boost::shared_ptr<DownloadContext> DownloadContextRefp;
        typedef std::pair<ustring, ustring> DownloadKey;
        typedef std::map<DownloadKey, DownloadContextRefp> DownloadMap;
    }
}

#endif // BMP_NETWORK_TYPES_HH
